local AceGUI = LibStub("AceGUI-3.0")
local classFilter = {}
local guild = {}
local mains = {}
local tmains = {}

function DEDKP_ClassManager_Init()
	classFilter = {}
end

function DEDKP_ClassManager_Show()
	DEDKP_ClassManager_Init()

	DERR.ClassManager = AceGUI:Create("Frame")
	DERR.ClassManager:SetTitle("Draconis Erus Class Manager")
	DERR.ClassManager:SetLayout("Flow")
	DERR.ClassManager:SetWidth(630)
	DERR.ClassManager:SetHeight(600)
	DERR.ClassManager:EnableResize(false)
	DERR.ClassManager:SetCallback("OnClose", DEDKP_ClassManager_OnClose)

	--Guild Scroll
	DERR.ClassManager.GuildContainer = AceGUI:Create("InlineGroup")
	DERR.ClassManager.GuildContainer:SetLayout("Fill")
	DERR.ClassManager.GuildContainer:SetWidth(250)
	DERR.ClassManager.GuildContainer:SetHeight(500)
	DERR.ClassManager.GuildContainer:SetTitle("Guild List:")
	DERR.ClassManager:AddChild(DERR.ClassManager.GuildContainer)

	DERR.ClassManager.GuildScroll = AceGUI:Create("ScrollFrame")
	DERR.ClassManager.GuildScroll:SetLayout("Flow")
	DERR.ClassManager.GuildContainer:AddChild(DERR.ClassManager.GuildScroll)

	--Roles
	DERR.ClassManager.RoleContainer = AceGUI:Create("InlineGroup")
	DERR.ClassManager.RoleContainer:SetLayout("Fill")
	DERR.ClassManager.RoleContainer:SetWidth(165)
	DERR.ClassManager.RoleContainer:SetHeight(500)
	DERR.ClassManager.RoleContainer:SetTitle("Roles:")
	DERR.ClassManager:AddChild(DERR.ClassManager.RoleContainer)

	DERR.ClassManager.RoleScroll = AceGUI:Create("ScrollFrame")
	DERR.ClassManager.RoleScroll:SetLayout("Flow")
	DERR.ClassManager.RoleContainer:AddChild(DERR.ClassManager.RoleScroll)

	--Controls
	DERR.ClassManager.ControlContainer = AceGUI:Create("InlineGroup")
	DERR.ClassManager.ControlContainer:SetLayout("DERR_Layout")
	DERR.ClassManager.ControlContainer:SetWidth(165)
	DERR.ClassManager.ControlContainer:SetHeight(500)
	DERR.ClassManager.ControlContainer:SetTitle("Options: ")
	DERR.ClassManager:AddChild(DERR.ClassManager.ControlContainer)

	DERR.ClassManager.FilterGroup = AceGUI:Create("SimpleGroup")
	DERR.ClassManager.FilterGroup:SetWidth(165)
	DERR.ClassManager:AddChild(DERR.ClassManager.FilterGroup)

	DERR.ClassManager.Class = AceGUI:Create("Dropdown")
	DERR.ClassManager.Class:SetWidth(165)
	DERR.ClassManager.Class:SetList(dedkp_class_list)
	DERR.ClassManager.Class:SetMultiselect(false)
	DERR.ClassManager.Class:SetValue(0)
	DERR.ClassManager.Class:SetCallback("OnValueChanged",DEDKP_ClassManager_OnValueChanged)
	DERR.ClassManager.FilterGroup:AddChild(DERR.ClassManager.Class)

	DERR.ClassManager.Save = AceGUI:Create("Button")
	DERR.ClassManager.Save:SetWidth(120)
	DERR.ClassManager.Save:SetHeight(20)
	DERR.ClassManager.Save:SetText("Save")
	DERR.ClassManager.Save:SetCallback("OnClick",DEDKP_ClassManager_Save_OnClick)
	DERR.ClassManager:AddChild(DERR.ClassManager.Save)

	DEDKP_ClassManager_LoadGuild()

	DraconisErus_SetWindowPosition("ClassManager", DERR.ClassManager)

end

function DEDKP_ClassManager_ClearPlayer()
	local button = DERR.ClassManager.Save.guildentry
	if button then
		local member = button.member
		if member then
			button.clicked = false
			if member.isMain then
				button:SetText("|c"..dedkp_class_info[member.class].h..member.name.."|r |cff00ff00(M)|r")
			else
				button:SetText("|c"..dedkp_class_info[member.class].h..member.name.."|r |cffff0000(A)|r - "..member.main)
			end 
		end
	end
	DERR.ClassManager.RoleScroll:ReleaseChildren()
	DERR.ClassManager.ControlContainer:ReleaseChildren()
	DERR.ClassManager.Save.player = nil
	DERR.ClassManager.Save.roles = {}
	DERR.ClassManager.Save.guildentry = nil
end

function DEDKP_ClassManager_LoadPlayer(button)
	local member = button.member
	DraconisErus_Debug("player:"..member.name)

	DEDKP_ClassManager_ClearPlayer()
	if not button.clicked then return end

	DERR.ClassManager.Save.guildentry = button

	table.sort(DEDKP_PRIORITY_ROLES, function(a, b)
	    	return a.name < b.name
  	end)

	for key, value in pairs(DEDKP_PRIORITY_ROLES) do
		local index = DraconisErus_TableSearch(member.roles,value.id)
		if index > 0 then
			DEDKP_ClassManager_AddRoleEntry(value, true, member)
		else
			DEDKP_ClassManager_AddRoleEntry(value, false, member)
		end
	end

	DERR.ClassManager.Main = AceGUI:Create("CheckBox")
	DERR.ClassManager.Main:SetType("radio")
	DERR.ClassManager.Main:SetLabel("Main")
	DERR.ClassManager.Main:SetValue(member.isMain)
	DERR.ClassManager.Main:SetWidth(160)
	DERR.ClassManager.Main:SetCallback("OnValueChanged", DEDKP_ClassManager_Main_OnValueChanged)
	DERR.ClassManager.ControlContainer:AddChild(DERR.ClassManager.Main)

	DERR.ClassManager.ControlContainer:AddChild(AceGUI:Create("Label"))

	DERR.ClassManager.Alt = AceGUI:Create("CheckBox")
	DERR.ClassManager.Alt:SetType("radio")
	DERR.ClassManager.Alt:SetLabel("Alt")
	DERR.ClassManager.Alt:SetValue(not member.isMain)
	DERR.ClassManager.Alt:SetWidth(160)
	DERR.ClassManager.Alt:SetCallback("OnValueChanged", DEDKP_ClassManager_Alt_OnValueChanged)
	DERR.ClassManager.ControlContainer:AddChild(DERR.ClassManager.Alt)

	DERR.ClassManager.AltMain = AceGUI:Create("Dropdown")
	DERR.ClassManager.AltMain:SetWidth(150)
	DERR.ClassManager.AltMain:SetList(mains)
	DERR.ClassManager.AltMain.mains = mains
	DERR.ClassManager.AltMain:SetMultiselect(false)
	if member.isMain then
		DERR.ClassManager.AltMain:SetValue(0)
	else
		if member.main and member.main ~= "" then
			DERR.ClassManager.AltMain:SetText(member.main)
			DERR.ClassManager.AltMain.main = member.main
		end
	end
	DERR.ClassManager.AltMain:SetCallback("OnValueChanged",DEDKP_ClassManager_AltMain_OnValueChanged)
	DERR.ClassManager.ControlContainer:AddChild(DERR.ClassManager.AltMain)

end

function DEDKP_ClassManager_OnValueChanged(widget, event, key)
	DEDKP_ClassManager_ClearPlayer()
	local className = dedkp_class_list[key]
	classFilter = {}
	table.insert(classFilter,className)
	DEDKP_ClassManager_LoadGuild()
end

function DEDKP_ClassManager_LoadGuild()
	guild, mains = DraconisErus_Guild_GetGuild()
	
	if classFilter == nil then classFilter = "" end

	DERR.ClassManager.GuildScroll:ReleaseChildren()
	for index, member in pairs(guild) do
		local localClass = dedkp_class_info[member.class].localName
		if next(classFilter) == nil then	--No filter
			DEDKP_ClassManager_AddGuildEntry(member)
		elseif DraconisErus_TableSearch(classFilter, localClass) > 0 then	--Class filter
			DEDKP_ClassManager_AddGuildEntry(member)
		end
	end
end

function DEDKP_ClassManager_AddGuildEntry(member)
	local g = AceGUI:Create("SimpleGroup")
	g:SetLayout("Flow")

	local il = AceGUI:Create("InteractiveLabel")
	if member.isMain then
		il:SetText("|c"..dedkp_class_info[member.class].h..member.name.."|r |cff00ff00(M)|r")
	else
		il:SetText("|c"..dedkp_class_info[member.class].h..member.name.."|r |cffff0000(A)|r - "..member.main)
	end
	il:SetHighlight("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	il:SetWidth(225)
	il.member = member
	il.clicked = false
	il:SetCallback("OnClick",DEDKP_ClassManager_GuildEntry_OnClick)
	g:AddChild(il)


	DERR.ClassManager.GuildScroll:AddChild(g)

end

function DEDKP_ClassManager_AddRoleEntry(role, checked, member)
	local g = AceGUI:Create("SimpleGroup")
	g:SetLayout("Flow")

	local locked = false
	if member.class == strupper(role.name) then
		checked = true
		locked = true
	end
	if role.name == "Guild" then
		locked = true
	end

	if checked then
		table.insert(DERR.ClassManager.Save.roles,role.id)
	end

	local il = AceGUI:Create("InteractiveLabel")
	il:SetWidth(160)
	if checked then
		il:SetColor(0,1,0)
	end
	il.locked = locked
	il:SetText(role.name)
	il:SetCallback("OnClick", DEDKP_ClassManager_RoleEntry_OnClick)
	il.roleid = role.id
	g:AddChild(il)

	DERR.ClassManager.RoleScroll:AddChild(g)

end

function DEDKP_ClassManager_GuildEntry_OnClick(button)
	local member = button.member
	if member then
		button.clicked = not button.clicked
		if button.clicked then
			if member.isMain then
				button:SetText("|cff00ff00"..member.name.."|r |cff00ff00(M)|r")
			else
				button:SetText("|cff00ff00"..member.name.."|r |cffff0000(A)|r - "..member.main)
			end 
		end
		DEDKP_ClassManager_LoadPlayer(button)
	end
end

function DEDKP_ClassManager_Save_OnClick(button)
	local isMain = false
	local member = button.guildentry.member
	if not member then return end
	local idx = DraconisErus_TableSearch(mains,member.name)
	if DERR.ClassManager.Main:GetValue() then
		member.isMain = true
		member.main = "{Main}"
		if idx == 0 then
			table.insert(mains,member.name)
		end
	end
	if DERR.ClassManager.Alt:GetValue() then
		member.isMain = false
		member.main = DERR.ClassManager.AltMain.main
		if idx > 0 then
			table.remove(mains,idx)
		end
	end

	local oNote = DraconisErus_TableToString(button.roles)
	member.roles = button.roles
	DraconisErus_Debug("saverole:"..oNote)
	oNote = member.main..";"..oNote
	local guildSize,_,_ = GetNumGuildMembers()
	for i=1, tonumber(guildSize) do
		local gname,_,_,_,_,_,_,gonote,_,_,gclass = GetGuildRosterInfo(i)
		gname = DraconisErus_FixName(gname)
		if gname == member.name then
			DraconisErus_Debug("save:"..gname..tostring(i))
			GuildRosterSetOfficerNote(i, oNote)
			break
		end
	end

	DEDKP_ClassManager_ClearPlayer()

end

function DEDKP_ClassManager_OnClose(widget)
	if DERR.ClassManager ~= nil then
		DraconisErus_SaveWindowPosition("ClassManager", widget)
		widget:ReleaseChildren()
		widget:Hide()
		DERR.ClassManager = nil
	end
end

function DEDKP_ClassManager_RoleEntry_OnClick(button)
	if button.locked then return end
	local roleid = button.roleid
	local index = DraconisErus_TableSearch(DERR.ClassManager.Save.roles,roleid)

	if index > 0 then
		table.remove(DERR.ClassManager.Save.roles,index)
		button:SetColor(1,1,1)
	else
		table.insert(DERR.ClassManager.Save.roles,roleid)
		button:SetColor(0,1,0)
	end	
end

function DEDKP_ClassManager_Main_OnValueChanged(widget, event, value)
	if value then
		DERR.ClassManager.Alt:SetValue(false)
	end	
end

function DEDKP_ClassManager_Alt_OnValueChanged(widget, event, value)
	if value then
		DERR.ClassManager.Main:SetValue(false)
	end	
end

function DEDKP_ClassManager_AltMain_OnValueChanged(widget, event, key)
	widget.main = widget.mains[key]
end
