
local LibCompress = LibStub:GetLibrary("LibCompress")
local LibCompressAddonEncodeTable = LibCompress:GetAddonEncodeTable()

function DraconisErusRaidRecorder:Comm_Addon(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,0) then return end
	if not DraconisErus_SenderAuth(sender,1,0,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "RAID") then
		if DraconisErus_Guild_HasPlayer(sender) then
			DraconisErus_Debug("<-"..prefix..":"..sender)
			if DraconisErus_TableSearch(DEDKPSettings["AddonUsers"],sender) == 0 then
				table.insert(DEDKPSettings["AddonUsers"],sender)
			end
		end
	end	
end

function DraconisErusRaidRecorder:Comm_Start_Raid(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,0) then return end
	if not DraconisErus_SenderAuth(sender,1,1,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "RAID") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			DraconisErus_RaidEvent_StartRaid(deserialized[1],deserialized[2],sender)
		else
			DraconisErus_Debug("Prefix:"..prefix..":Decode FAILED!")
		end
	end
end

function DraconisErusRaidRecorder:Comm_End_Raid(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,1) then return end
	if not DraconisErus_SenderAuth(sender,1,1,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "RAID") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			DraconisErus_RaidEvent_EndRaid(sender)
		else
			DraconisErus_Debug("Prefix:"..prefix..":Decode FAILED!")
		end
	end
end

function DraconisErusRaidRecorder:Comm_Start_Loot(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,1) then return end
	if not DraconisErus_SenderAuth(sender,1,1,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "RAID") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DERR_INBID = true
			DraconisErus_Debug("<-"..prefix..": "..decoded..": "..sender)
			DERR_BID_OFFICER = sender
			for index, value in pairs(deserialized[5]) do
				DEDKPPoints[DERR_REALM][DERR_GUILD][index] = value
			end
			local _, classFile = UnitClass("player")
			if deserialized[4] == "" then
				DEDKP_BidWindow_Show(deserialized[1],deserialized[2],deserialized[3])
			elseif DraconisErus_TableSearch(deserialized[4],classFile) > 0 then
				DEDKP_BidWindow_Show(deserialized[1],deserialized[2],deserialized[3])
			end
		else
			DraconisErus_Debug("Prefix:"..prefix..":Decode FAILED!")
		end
	end
end

function DraconisErusRaidRecorder:Comm_End_Loot(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,1) then return end
	if not DraconisErus_SenderAuth(sender,1,1,1) then return end
	if sender ~= DERR_BID_OFFICER then return end --sender must be original bid officer
	if (prefix and DERR_PLAYER ~= sender and distribution == "RAID") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			DERR_BID_OFFICER = ""
			DERR_INBID = false
			if DERR.BidWindow ~= nil then DEDKP_BidWindow_BidTimerBar_OnEnd() end
		else
			DraconisErus_Debug("Prefix:"..prefix..":Decode FAILED!")
		end
	end
end

function DraconisErusRaidRecorder:Comm_Bid(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(1,1,1) then return end
	if not DraconisErus_SenderAuth(sender,1,0,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "WHISPER") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			DEDKP_BidManager_AddBid(sender,deserialized)
		else
			DraconisErus_Debug("Prefix:"..prefix..":Decode FAILED!")
		end
	end
end

function DraconisErusRaidRecorder:Comm_Bid_Done(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(1,1,1) then return end
	if not DraconisErus_SenderAuth(sender,1,0,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "WHISPER") then
		local pIndex = DraconisErus_TableSearch(DERR_BIDDERS,sender)
		if pIndex > 0 then table.remove(DERR_BIDDERS,pIndex) end
		if next(DERR_BIDDERS) == nil then
			if DERR.BidManager ~= nil then
				if DERR_INBID then
					DEDKP_BidManager_StartButton_OnClick()
				end
			end
		end
	end
end

function DraconisErusRaidRecorder:Comm_Bid_Confirm(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,1) then return end
	if not DraconisErus_SenderAuth(sender,1,1,1) then return end
	if sender ~= DERR_BID_OFFICER then return end --sender must be bidofficer
	if (prefix and DERR_PLAYER ~= sender and distribution == "WHISPER") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			if DERR.BidWindow ~= nil then DEDKP_BidWindow_ConfirmBid(deserialized) end
		else
			DraconisErus_Debug("Prefix:"..prefix..":Decode FAILED!")
		end
	end
end

function DraconisErusRaidRecorder:Comm_Boss_Kill(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,1) then return end
	if not DraconisErus_SenderAuth(sender,1,0,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "RAID") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			C_Timer.After(0,function()
				C_Timer.After(2,function()
					DraconisErus_RaidEvent_BossKill(deserialized[1],nil,deserialized[2],sender)
				end)
			end)

		end
	end
end

function DraconisErusRaidRecorder:Comm_Award_Loot(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,0) then return end
	if not DraconisErus_SenderAuth(sender,1,1,0) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "GUILD") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			local lootEntry = deserialized
			local item = Item:CreateFromItemID(lootEntry.ItemID)
			item:ContinueOnItemLoad(function()
				DraconisErus_RaidEvent_Loot(lootEntry,sender)
			end)
		else
			DraconisErus_Debug("Prefix:"..prefix..":Decode FAILED!")
		end
	end
end

function DraconisErusRaidRecorder:Comm_Add_Standby(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,0) then return end
	if not DraconisErus_SenderAuth(sender,1,1,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "RAID") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			DraconisErus_Queue_Add(deserialized, sender)
		else
			DraconisErus_Debug("Prefix:"..prefix..":Decode FAILED!")
		end
	end
end

function DraconisErusRaidRecorder:Comm_Remove_Standby(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,0) then return end
	if not DraconisErus_SenderAuth(sender,1,1,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "RAID") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			DraconisErus_Queue_Remove(deserialized,sender)
		else
			DraconisErus_Debug("Prefix:"..prefix..":Decode FAILED!")
		end
	end
end

function DraconisErusRaidRecorder:Comm_Send_Raid(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,0) then return end
	if not DraconisErus_SenderAuth(sender,1,0,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "WHISPER") then
		DraconisErus_Debug("<-"..prefix..":"..sender)
		local raiddata = {}
		if DEDKPSettings["RaidStarted"] then
			table.insert(raiddata, DEDKPSettings)
			table.insert(raiddata, DEDKPRaids[DERR_REALM][DERR_GUILD][DEDKPSettings["RaidID"]])
		else
			table.insert(raiddata, DEDKPSettings["RaidQueue"])
		end
		DraconisErus_Comm_Send("DERRRECEIVERAID", raiddata, "WHISPER", sender)
	end	
end

function DraconisErusRaidRecorder:Comm_Receive_Raid(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,0) then return end
	if not DraconisErus_SenderAuth(sender,1,0,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "WHISPER") then
		if DERR_WAIT_FOR_RAID then
			DERR_WAIT_FOR_RAID = false
			local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
			if success then
				DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
				if table.getn(deserialized) == 1 then
					DEDKPSettings["RaidQueue"] = deserialized[1]
					if DERR.MainWindow ~= nil then DEDKP_MainWindow_LoadStandBy() end
				else
					DEDKPSettings = deserialized[1]
					DEDKPRaids[DERR_REALM][DERR_GUILD][DEDKPSettings["RaidID"]] = deserialized[2]
					DraconisErusRaidRecorder:Print("Raid synced.")
				end
				C_Timer.After(3,DraconisErus_RaidEvent_Send_Addon)
			else
				DraconisErus_Debug("Unable to receive raid from "..sender.."!")
			end
		end
	end
end

function DraconisErusRaidRecorder:Comm_Version(prefix, message, distribution, sender)
	if not DraconisErus_SenderAuth(sender,1,0,0) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "GUILD") then
		DEDKP_VersionWindow_RemoveVersion(sender)
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			local v = deserialized[1]
			local t = deserialized[2]
			local s = 0
			if deserialized[1] ~= DERR_VERSION then
				if tonumber(deserialized[2]) > DERR_VERSION_STAMP then
					if not DERR_OUT_OF_DATE then
						DraconisErusRaidRecorder:Print("|cffff0000A new version is available! Please Upgrade!|r")
						DraconisErus_PlayNewVersion()
						DERR_OUT_OF_DATE = true;
					end
					s = 3
				else
					s = 2
				end
			else
				s = 1
			end
			table.insert(DERR_USERS, { player = sender, version = v, timestamp = t, sort = s })
			if DERR.VersionWindow ~= nil then DEDKP_VersionWindow_LoadVersions() end
		end
		if GetServerTime() - DERR_LAST_VERSION_CHECK >= 10 then
			DERR_LAST_VERSION_CHECK = GetServerTime()
			DraconisErus_Comm_Send("DERRVERSION",DERR_VERSION_DATA,"GUILD")
		end
	end
end

function DraconisErusRaidRecorder:Comm_Ping(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,0) then return end
	if not DraconisErus_SenderAuth(sender,1,0,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "RAID") then
		DraconisErus_Debug("<-"..prefix..":"..sender)
		DraconisErus_Comm_Send("DERRPONG","","WHISPER",sender)
	end
end

function DraconisErusRaidRecorder:Comm_Pong(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(0,1,0) then return end
	if not DraconisErus_SenderAuth(sender,1,0,1) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "WHISPER") then
		DraconisErus_Debug("<-"..prefix..":"..sender)
		if DraconisErus_TableSearch(DEDKPSettings["AddonUsers"],sender) == 0 then
			table.insert(DEDKPSettings["AddonUsers"],sender)
		end
	end
end

function DraconisErusRaidRecorder:Comm_Level(prefix, message, distribution, sender)
	if not DraconisErus_SenderAuth(sender,1,0,0) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "GUILD") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			local class = DraconisErus_Guild_GetClass(sender)
			DraconisErusRaidRecorder:Print(DraconisErus_Class_Colorize(class,strupper(sender)).." |cffffd700 IS NOW LEVEL "..deserialized.."!|r")
		end
		DraconisErus_Guild_Save(sender,deserialized)
	end
end

function DraconisErusRaidRecorder:Comm_SendPoints(prefix, message, distribution, sender)
	if not DraconisErus_PlayerAuth(1,0,0) then return end
	if not DraconisErus_SenderAuth(sender,1,0,0) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "WHISPER") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			DraconisErus_Comm_Send("DERRGETDKP",DEDKPPoints[DERR_REALM][DERR_GUILD],"WHISPER",sender)
		end
	end
end

function DraconisErusRaidRecorder:Comm_ReceivePoints(prefix, message, distribution, sender)
	if not DraconisErus_SenderAuth(sender,1,1,0) then return end
	if (prefix and DERR_PLAYER ~= sender and (distribution == "WHISPER" or distribution == "GUILD")) then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			local lastImport = DEDKPSettings["LastImport"]
			if (lastImport == "" or lastImport == nil) then lastImport = "0" end
			local thisImport = deserialized["!VERSION"]
			if (thisImport == "" or thisImport == nil) then thisImport = "0" end
			if tonumber(lastImport) < tonumber(thisImport) then
				DEDKPSettings["LastImport"] = thisImport
				DEDKPPoints[DERR_REALM][DERR_GUILD] = deserialized
				if DERR.MainWindow ~= nil then DEDKP_MainWindow_LoadGuild() end
			end
		end
	end
end

function DraconisErusRaidRecorder:Comm_SendRole(prefix, message, distribution, sender)
	local retVal = {}
	if not DraconisErus_PlayerAuth(1,1,0) then return end
	if not DraconisErus_SenderAuth(sender,1,0,0) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "WHISPER") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			local oNote = DraconisErus_Guild_GetOfficerNote(sender)
			DraconisErus_Comm_Send("DERRROLE",oNote,"WHISPER",sender)
		end
	end
end

function DraconisErusRaidRecorder:Comm_ReceiveRole(prefix, message, distribution, sender)
	if not DraconisErus_SenderAuth(sender,1,1,0) then return end
	if (prefix and DERR_PLAYER ~= sender and distribution == "WHISPER") then
		local success,decoded,deserialized = DraconisErus_Comm_DecodeMessage(message)
		if success then
			DraconisErus_Debug("<-"..prefix..":"..decoded..":"..sender)
			local tblRoles = {}
			local oNote = deserialized
			DEDKPRoles = oNote
			if DERR.MainWindow then
				DEDKP_MainWindow_ShowRoles()
			end
		end
	end
end

function DraconisErus_Comm_Send(prefix, message, distribution, destination)
	local serialized, encoded = DraconisErus_Comm_EncodeMessage(message)
	if destination == nil then
		DraconisErus_Debug("->"..prefix..":"..serialized)
	else
		DraconisErus_Debug("->"..prefix..":"..serialized..":"..destination)
	end
	DraconisErusRaidRecorder:SendCommMessage(prefix, encoded, distribution, destination)
end

function DraconisErus_Comm_DecodeMessage(message)
	local decoded = LibCompress:Decompress(LibCompressAddonEncodeTable:Decode(message))
	local success, deserialized = DraconisErusRaidRecorder:Deserialize(decoded)
	return success, decoded, deserialized
end

function DraconisErus_Comm_EncodeMessage(message) --cannot be empty string, send "nil" (as test) if necessary
	local serialized = DraconisErusRaidRecorder:Serialize(message)
	-- compress serialized string with both possible compressions for comparison
	-- I do both in case one of them doesn't retain integrity after decompression and decoding, the other is sent
	local huffmanCompressed = LibCompress:CompressHuffman(serialized)
	if huffmanCompressed then
		huffmanCompressed = LibCompressAddonEncodeTable:Encode(huffmanCompressed)
	end
	local lzwCompressed = LibCompress:CompressLZW(serialized)
	if lzwCompressed then
		lzwCompressed = LibCompressAddonEncodeTable:Encode(lzwCompressed)
	end

	-- Decode to test integrity
	local test1 = LibCompress:Decompress(LibCompressAddonEncodeTable:Decode(huffmanCompressed))
	if test1 == serialized then
		verInteg1 = true
	end
	local test2 = LibCompress:Decompress(LibCompressAddonEncodeTable:Decode(lzwCompressed))
	if test2 == serialized then
		verInteg2 = true
	end
	-- check which string with verified integrity is shortest. Huffman usually is
	if (strlen(huffmanCompressed) < strlen(lzwCompressed) and verInteg1 == true) then
		packet = huffmanCompressed
	elseif (strlen(huffmanCompressed) > strlen(lzwCompressed) and verInteg2 == true) then
		packet = lzwCompressed
	elseif (strlen(huffmanCompressed) == strlen(lzwCompressed)) then
		if verInteg1 == true then packet = huffmanCompressed
		elseif verInteg2 == true then packet = lzwCompressed end
	end

	return serialized, packet

end


