local AceGUI = LibStub("AceGUI-3.0")

function DEDKP_LootManager_LoadItem(button)

	local lootEntry = button.lootEntry
	local loot_link = button.loot_link
	local linktext = button.linktext

	DERR.LootManager.DetailsContainer:ReleaseChildren()

	if lootEntry == nil then return end
	if lootEntry.ItemID == nil then return end

	local players = {}
	for index, value in pairs(lootEntry.Players) do
		if value ~= lootEntry.Player then
			table.insert(players,value)
		end
	end

	DERR.LootManager.ItemName = AceGUI:Create("InteractiveLabel")
	DERR.LootManager.ItemName:SetWidth(165)
	DERR.LootManager.ItemName:SetText(linktext)
	DERR.LootManager.ItemName.loot_link = loot_link
	DERR.LootManager.ItemName:SetCallback("OnEnter",DEDKP_LootManager_LootIcon_OnEnter)
	DERR.LootManager.ItemName:SetCallback("OnLeave",DEDKP_LootManager_LootIcon_OnLeave)
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.ItemName)

	DERR.LootManager.OriginalWinner = AceGUI:Create("Label")
	DERR.LootManager.OriginalWinner:SetWidth(165)
	DERR.LootManager.OriginalWinner:SetText("Winner: "..lootEntry.Player)
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.OriginalWinner)

	DERR.LootManager.OriginalAmount = AceGUI:Create("Label")
	DERR.LootManager.OriginalAmount:SetWidth(165)
	DERR.LootManager.OriginalAmount:SetText("Amount: "..lootEntry.Amount)
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.OriginalAmount)

	DERR.LootManager.OriginalAction = AceGUI:Create("Label")
	DERR.LootManager.OriginalAction:SetWidth(165)
	DERR.LootManager.OriginalAction:SetText("Action: "..lootEntry.Action)
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.OriginalAction)

	DERR.LootManager.DetailsContainer:AddChild(AceGUI:Create("Label"))
	DERR.LootManager.DetailsContainer:AddChild(AceGUI:Create("Label"))

	DERR.LootManager.pLabel = AceGUI:Create("Label")
	DERR.LootManager.pLabel:SetWidth(165)
	DERR.LootManager.pLabel:SetText("Player: ")
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.pLabel)

	DERR.LootManager.Players = AceGUI:Create("Dropdown")
	DERR.LootManager.Players:SetWidth(165)
	DERR.LootManager.Players.List = players
	DERR.LootManager.Players:SetList(players)
	DERR.LootManager.Players:SetMultiselect(false)
	DERR.LootManager.Players:SetValue(0)
	DERR.LootManager.Players:SetCallback("OnValueChanged",DEDKP_LootManager_Players_OnValueChanged)
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.Players)

	DERR.LootManager.pAction = AceGUI:Create("Label")
	DERR.LootManager.pAction:SetWidth(165)
	DERR.LootManager.pAction:SetText("Action: ")
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.pAction)

	local actions = { "AWARD", "BANK", "SHARD" }
	DERR.LootManager.Action = AceGUI:Create("Dropdown")
	DERR.LootManager.Action:SetWidth(165)
	DERR.LootManager.Action.List = actions
	DERR.LootManager.Action:SetList(actions)
	DERR.LootManager.Action:SetMultiselect(false)
	DERR.LootManager.Action:SetValue(0)
	DERR.LootManager.Action:SetCallback("OnValueChanged",DEDKP_LootManager_Action_OnValueChanged)
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.Action)


	DERR.LootManager.pAmount = AceGUI:Create("Label")
	DERR.LootManager.pAmount:SetWidth(165)
	DERR.LootManager.pAmount:SetText("Amount: ")
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.pAmount)

	DERR.LootManager.NewAmount = AceGUI:Create("EditBox")
	DERR.LootManager.NewAmount:SetWidth(165)
	--DERR.LootManager.NewAmount:SetCallback("OnTextChanged",DEDKP_Filter_OnTextChanged)
	DERR.LootManager.NewAmount:DisableButton(true)
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.NewAmount)

	--Bids Details
	DERR.LootManager.BidsContainer = AceGUI:Create("InlineGroup")
	DERR.LootManager.BidsContainer:SetLayout("Fill")
	DERR.LootManager.BidsContainer:SetWidth(165)
	DERR.LootManager.BidsContainer:SetHeight(100)
	DERR.LootManager.BidsContainer:SetTitle("Bids: ")
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.BidsContainer)

	DERR.LootManager.BidScroll = AceGUI:Create("ScrollFrame")
	DERR.LootManager.BidScroll:SetLayout("Flow")
	DERR.LootManager.BidsContainer:AddChild(DERR.LootManager.BidScroll)


	DERR.LootManager.Submit = AceGUI:Create("Button")
	DERR.LootManager.Submit:SetText("Submit")
	DERR.LootManager.Submit:SetWidth(165)
	DERR.LootManager.Submit:SetHeight(20)
	DERR.LootManager.Submit:SetCallback("OnClick",DEDKP_LootManager_Submit_OnClick)
	DERR.LootManager.Submit.lootEntry = lootEntry
	DERR.LootManager.DetailsContainer:AddChild(DERR.LootManager.Submit)

	DEDKP_LootManager_LoadBids(lootEntry.Bids)


end

function DEDKP_LootManager_Submit_OnClick(button)
	local lootEntry = button.lootEntry

	local action = DERR.LootManager.Action.List[DERR.LootManager.Action.Action]
	local player = DERR.LootManager.Players.List[DERR.LootManager.Players.Player]
	if action == nil or action == "" then
		DraconisErusRaidRecorder:Print("|cFFFF0000Invalid action!|r")
		return
	else
		lootEntry.Action = "REFUND"
		DraconisErus_RaidEvent_Loot(lootEntry)
		DraconisErus_Debug("action:"..action)
		if action == "BANK" or action == "SHARD" then
			local newLootEntry = {
				["LootID"] = DraconisErus_GenerateID(false),
				["RaidID"] = DEDKPSettings["RaidID"],
				["ItemID"] = lootEntry.ItemID,
				["Action"] = action,
				["Player"] = DERR_PLAYER,
				["Bid"] = 0,
				["Amount"] = 0,
				["Bids"] = lootEntry.Bids,
				["Players"] = lootEntry.Players
			}
			DraconisErus_RaidEvent_Loot(newLootEntry)
		end
		if action == "AWARD" then
			if player == "" or player == nil then
				DraconisErusRaidRecorder:Print("|cFFFF0000Invalid player!|r")
				return
			end
			local amount = DERR.LootManager.NewAmount:GetText()
			amount = tonumber(amount)
			if amount == nil then
				DraconisErusRaidRecorder:Print("|cFFFF0000Invalid amount!|r")
			else
				local newLootEntry = {
					["LootID"] = DraconisErus_GenerateID(false),
					["RaidID"] = DEDKPSettings["RaidID"],
					["ItemID"] = lootEntry.ItemID,
					["Action"] = action,
					["Player"] = player,
					["Bid"] = 0,
					["Amount"] = amount,
					["Bids"] = lootEntry.Bids,
					["Players"] = lootEntry.Players
				}
				DraconisErus_RaidEvent_Loot(newLootEntry)
			end
		end
		DEDKP_LootManager_LoadLoot()
	end
end

function DEDKP_LootManager_Init()
	classes = {}
	bids = {}
	raiders = {}
	selected_player = ""
	selected_bid = 0
end

function DEDKP_LootManager_Action_OnValueChanged(widget, event, key, checked)
	widget.Action = key
end

function DEDKP_LootManager_Players_OnValueChanged(widget, event, key, checked)
	widget.Player = key
end

function DEDKP_LootManager_Show()
	DEDKP_LootManager_Init()

	DERR.LootManager = AceGUI:Create("Frame")
	DERR.LootManager:SetTitle("Draconis Erus Loot Manager")
	DERR.LootManager:SetLayout("Flow")
	DERR.LootManager:SetWidth(565)
	DERR.LootManager:SetHeight(450)
	DERR.LootManager:EnableResize(false)
	DERR.LootManager:SetCallback("OnClose", DEDKP_LootManager_OnClose)

	--Loot Scroll
	DERR.LootManager.LootContainer = AceGUI:Create("InlineGroup")
	DERR.LootManager.LootContainer:SetLayout("Fill")
	DERR.LootManager.LootContainer:SetWidth(330)
	DERR.LootManager.LootContainer:SetHeight(375)
	DERR.LootManager.LootContainer:SetTitle("Loot:")
	DERR.LootManager:AddChild(DERR.LootManager.LootContainer)

	DERR.LootManager.LootScroll = AceGUI:Create("ScrollFrame")
	DERR.LootManager.LootScroll:SetLayout("Flow")
	DERR.LootManager.LootContainer:AddChild(DERR.LootManager.LootScroll)


	--Loot Details
	DERR.LootManager.DetailsContainer = AceGUI:Create("InlineGroup")
	DERR.LootManager.DetailsContainer:SetLayout("DERR_Layout")
	DERR.LootManager.DetailsContainer:SetWidth(200)
	DERR.LootManager.DetailsContainer:SetHeight(375)
	DERR.LootManager.DetailsContainer:SetTitle("Details: ")
	DERR.LootManager:AddChild(DERR.LootManager.DetailsContainer)


	DraconisErus_SetWindowPosition("LootManager", DERR.LootManager)

	DEDKP_LootManager_LoadLoot()

end

function DEDKP_LootManager_LoadBids(bids)
	for index, value in pairs(bids) do
		DEDKP_LootManager_AddBidEntry(value)
	end
end

function DEDKP_LootManager_AddBidEntry(bidEntry)
	local g = AceGUI:Create("SimpleGroup")
	g:SetLayout("Flow")
	local class = DraconisErus_Guild_GetClass(bidEntry.player)
	local l = AceGUI:Create("Label")
	l:SetText(bidEntry.player)
	l:SetWidth(95)
	l:SetColor(dedkp_class_info[class].r,dedkp_class_info[class].g,dedkp_class_info[class].b)
	g:AddChild(l)

	local l = AceGUI:Create("Label")
	l:SetText(tostring(bidEntry.bid))
	l:SetWidth(25)
	l:SetColor(dedkp_class_info[class].r,dedkp_class_info[class].g,dedkp_class_info[class].b)
	l:SetJustifyH("RIGHT")
	g:AddChild(l)

	DERR.LootManager.BidScroll:AddChild(g)

end

function DEDKP_LootManager_AddLootEntry(lootEntry)
	local g = AceGUI:Create("SimpleGroup")
	g:SetLayout("Flow")

	local il = AceGUI:Create("InteractiveLabel")
	il:SetText(lootEntry.Name)
	il:SetHighlight("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	il:SetWidth(175)
	il.lootEntry = lootEntry
	il:SetCallback("OnEnter",DEDKP_LootManager_LootIcon_OnEnter)
	il:SetCallback("OnLeave",DEDKP_LootManager_LootIcon_OnLeave)
	il:SetCallback("OnClick",DEDKP_LootManager_LootEntry_OnClick)
	local item = Item:CreateFromItemID(lootEntry.ItemID)
	item:ContinueOnItemLoad(function()
		local itemName,itemLink,itemRarity,_,_,_,_,_,_,itemIcon = GetItemInfo(lootEntry.ItemID)
		il.loot_link = itemLink
		local r, g, b, hex = GetItemQualityColor(itemRarity)
		il.linktext = "|c"..hex..itemName.."|r"
		il:SetText(il.linktext)
	end)
	g:AddChild(il)

	local class = DraconisErus_Guild_GetClass(lootEntry.Player)
	local l = AceGUI:Create("Label")
	l:SetText(lootEntry.Player)
	l:SetWidth(95)
	l:SetColor(dedkp_class_info[class].r,dedkp_class_info[class].g,dedkp_class_info[class].b)
	g:AddChild(l)

	local l = AceGUI:Create("Label")
	l:SetText(tostring(lootEntry.Amount))
	l:SetWidth(25)
	l:SetColor(dedkp_class_info[class].r,dedkp_class_info[class].g,dedkp_class_info[class].b)
	l:SetJustifyH("RIGHT")
	g:AddChild(l)

	DERR.LootManager.LootScroll:AddChild(g)

end

function DEDKP_LootManager_LootEntry_OnClick(button)
	if button.lootEntry == nil then return end
	DEDKP_LootManager_LoadItem(button)
end

function DEDKP_LootManager_LoadLoot()

	DERR.LootManager.LootScroll:ReleaseChildren()
	DERR.LootManager.DetailsContainer:ReleaseChildren()

	for index, value in pairs(DEDKPRaids[DERR_REALM][DERR_GUILD][DEDKPSettings["RaidID"]]) do
		if value["EVENT_TYPE"] == "RAID_LOOT" then
			DEDKP_LootManager_AddLootEntry(value["EVENT_DATA"])
		end
	end
end

function DEDKP_LootManager_LootIcon_OnEnter(widget)
	GameTooltip:SetOwner(widget.frame)
	GameTooltip:SetPoint("TOPLEFT")
	GameTooltip:SetHyperlink(widget.loot_link)
	GameTooltip:Show()
end

function DEDKP_LootManager_LootIcon_OnLeave()
	GameTooltip:Hide()
end

function DEDKP_LootManager_OnClose(widget)
	if DERR.LootManager ~= nil then
		DraconisErus_SaveWindowPosition("LootManager", widget)
		widget:ReleaseChildren()
		widget:Hide()
		DERR.LootManager = nil
	end
end