function DraconisErus_RaidEvent_StartRaid(RaidID, LootRaid, sender)
	if DEDKPSettings["RaidStarted"] then  --raid already started, ignore
		return
	end
	local raidstarter = false
	local raid_start = ""
	if RaidID == nil then
		RaidID = DraconisErus_GenerateID(true)
		raidstarter = true
	end
	if LootRaid == nil then
		LootRaid = false
	end
	DEDKPSettings["RaidID"] = RaidID
	DEDKPSettings["LootRaid"] = LootRaid
	DEDKPRaids[DERR_REALM][DERR_GUILD][DEDKPSettings["RaidID"]] = {}
	DEDKPLoot[DERR_REALM][DERR_GUILD][DEDKPSettings["RaidID"]] = {}
	DEDKPSettings["BossKills"] = {}
	DEDKPSettings["AddonUsers"] = {}
	players = DraconisErus_Raid_GetAllPlayers(true)
	if sender == nil then
		raid_start = DERR_PLAYER
	else
		raid_start = sender
	end
	local data = {
			["Time"] = GetServerTime(),
			["Players"] = players,
			["Loot"] = tostring(LootRaid),
			["StartedBy"] = raid_start
		}
	DraconisErus_RaidEvent_Add("RAID_START",data)
	DEDKPSettings["RaidStarted"] = true
	DraconisErus_RaidEvent_ZoneChange()
	if next(DEDKPPoints[DERR_REALM][DERR_GUILD]) == nil then
		DEDKPPoints[DERR_REALM][DERR_GUILD] = DraconisErus_Guild_GetEmptyPoints()
	end
	if raidstarter then
		draconiserus_inraid = true
		local raiddata = {}
		table.insert(raiddata,RaidID)
		table.insert(raiddata,LootRaid)
		DraconisErus_Comm_Send("DERRSTARTRAID", raiddata, "RAID")
		SendChatMessage("Raid started by "..DERR_PLAYER.."!","RAID_WARNING")
		local lootMethod = GetLootMethod()
		if lootMethod ~= "master" then
			SetLootMethod("master", UnitName("player"))
		end
		C_Timer.After(5,DraconisErus_RaidEvent_Send_Addon)
	else
		C_Timer.After(5,DraconisErus_RaidEvent_Send_Addon)
	end
	if DERR.MainWindow ~= nil then DEDKP_MainWindow_SetControls() end
end

function DraconisErus_RaidEvent_Send_Addon()
	DraconisErus_Comm_Send("DERRADDON","nil", "RAID")
	if DraconisErus_TableSearch(DEDKPSettings["AddonUsers"],DERR_PLAYER) == 0 then
		table.insert(DEDKPSettings["AddonUsers"],DERR_PLAYER)
	end
end

function DraconisErus_RaidEvent_PlayerJoined(player)
	if not DEDKPSettings["RaidStarted"] then
		return
	end
	DraconisErus_Debug("RAID_JOIN:"..player)
	local data = {
		["Time"] = GetServerTime(),
		["Name"] = player
	}
	DraconisErus_RaidEvent_Add("RAID_JOIN",data)
end

function DraconisErus_RaidEvent_PlayerLeft(player)
	if DEDKPSettings["RaidStarted"] == false then --if you were not there for the raid start, ignore
		return
	end
	DraconisErus_Debug("RAID_LEAVE:"..player)
	local index = DraconisErus_TableSearch(DEDKPSettings["AddonUsers"],player)
	if index > 0 then
		table.remove(DEDKPSettings["AddonUsers"],index)
	end
	local data = {
		["Time"] = GetServerTime(),
		["Name"] = player
	}
	DraconisErus_RaidEvent_Add("RAID_LEAVE",data)
	if DERR.MainWindow ~= nil then DEDKP_MainWindow_SetControls() end
end

function DraconisErus_RaidEvent_ZoneChange()
	if not DEDKPSettings["RaidStarted"] then --if you were not there for the raid start, ignore
		return
	end
	local data = {
		["Name"] = GetZoneText()
	}
	DraconisErus_RaidEvent_Add("RAID_ZONE",data)
end

function DraconisErus_RaidEvent_BossKill(bossname,zonetext,players,sender)
	if not DEDKPSettings["RaidStarted"] then --if you were not there for the raid start, ignore
		return
	end
	if DraconisErus_TableSearch(DEDKPSettings["BossKills"],bossname) > 0 then --boss already recorded
		return
	else
		table.insert(DEDKPSettings["BossKills"],bossname)
		local players = DraconisErus_Raid_GetAllPlayers(true)
		local data = {
			["Time"] = GetServerTime(),
			["Name"] = bossname,
			["Players"] = players
		}
		DraconisErus_RaidEvent_Add("RAID_BOSS",data)
		local commdata = {}
		table.insert(commdata,bossname)
		table.insert(commdata,players)
		DraconisErus_Comm_Send("DERRBOSSKILL",commdata, "RAID")
		if UnitIsGroupLeader("player") then
			if not DERR_DEBUG then
				SendChatMessage("BOSS KILL: " + bossname,"GUILD")
			end
		end
	end
end

function DraconisErus_RaidEvent_Loot(lootEntry,sender)
	if DEDKPSettings["RaidStarted"] and DEDKPSettings["RaidID"] == lootEntry.RaidID then --if raid has been started and the event is in your raid, record
		local itemName,itemLink,itemRarity,_,_,_,_,_,_,itemIcon = GetItemInfo(lootEntry.ItemID)
		lootEntry.Time = GetServerTime()
		lootEntry.Name = itemName
		if lootEntry.Action == "AWARD" then
			DEDKPPoints[DERR_REALM][DERR_GUILD][lootEntry.Player] = DEDKPPoints[DERR_REALM][DERR_GUILD][lootEntry.Player] - tonumber(lootEntry.Amount)
		end
		if lootEntry.Action == "REFUND" then
			DEDKPPoints[DERR_REALM][DERR_GUILD][lootEntry.Player] = DEDKPPoints[DERR_REALM][DERR_GUILD][lootEntry.Player] + tonumber(lootEntry.Amount)
			for index, value in pairs(DEDKPRaids[DERR_REALM][DERR_GUILD][DEDKPSettings["RaidID"]]) do
				if value["EVENT_TYPE"] == "RAID_LOOT" then
					local entry = value["EVENT_DATA"]
					if entry.LootID == lootEntry.LootID then
						table.remove(DEDKPRaids[DERR_REALM][DERR_GUILD][DEDKPSettings["RaidID"]],index)
						break											
					end
				end
			end
		else			
			DraconisErus_RaidEvent_Add("RAID_LOOT",lootEntry)
		end
		if sender == nil then
			if lootEntry.Action == "AWARD" then
				SendChatMessage("Congratulations to "..lootEntry.Player.." for winning "..itemLink.." for "..lootEntry.Amount.."("..lootEntry.Bid..") points!","RAID_WARNING")
				if not DERR_DEBUG then
					SendChatMessage("Congratulations to "..lootEntry.Player.." for winning "..itemLink.."!","GUILD")
				end
			elseif lootEntry.Action == "SHARD" or action == "BANK" then
				SendChatMessage(itemLink.." has been "..lootEntry.Action.."ED!","RAID_WARNING")
				--No reason to send bank or shard items to guild chat, would just cause drama
			end
			if lootEntry.Action == "REFUND" then
				SendChatMessage(lootEntry.Player.." has been REFUNDED "..lootEntry.Amount.." points for "..itemLink.."!","RAID_WARNING")
			end
			DraconisErus_Comm_Send("DERRAWARDLOOT", lootEntry, "GUILD")
		end
	elseif lootEntry.Action == "AWARD" then --either a raid has not been started or the loot is from a different raid and a player has been awarded loot, update points
		DEDKPPoints[DERR_REALM][DERR_GUILD][player] = DEDKPPoints[DERR_REALM][DERR_GUILD][player] - tonumber(lootEntry.Amount)
	end
	if DERR.MainWindow ~= nil then DEDKP_MainWindow_LoadGuild() end
end

function DraconisErus_RaidEvent_EndRaid(sender)
	if not DEDKPSettings["RaidStarted"] then return end
	local players = DraconisErus_Raid_GetAllPlayers(true)
	local raid_end = DERR_PLAYER
	if sender ~= nil then
		raid_end = sender
	end
	local data = {
			["Time"] = GetServerTime(),
			["Players"] = players,
			["EndedBy"] = raid_end
		}
	DraconisErus_RaidEvent_Add("RAID_END",data)
	local RaidID = DEDKPSettings["RaidID"]
	DEDKPSettings["RaidID"] = ""
	if sender == nil then
		DraconisErus_Comm_Send("DERRENDRAID", RaidID, "RAID")
		SendChatMessage(DERR_PLAYER.." has ended the raid!","RAID_WARNING")
	end
	DraconisErus_Guild_Save()
	DEDKPSettings["RaidStarted"] = false
	if DERR.MainWindow ~= nil then DEDKP_MainWindow_SetControls() end

end

function DraconisErus_RaidEvent_Add(event,data)
	local eventData = { 
		["EVENT_TYPE"] = event,
		["EVENT_DATA"]= data }
	table.insert(DEDKPRaids[DERR_REALM][DERR_GUILD][DEDKPSettings["RaidID"]], eventData)
end

function DraconisErus_LootEvent(data)
	table.insert(DEDKPLoot[DERR_REALM][DERR_GUILD][DEDKPSettings["RaidID"]], eventData)
end

function DraconisErus_Events_Clean()
	local newtable = {}
	for index, value in pairs(DEDKPRaids[DERR_REALM][DERR_GUILD]) do
		local d = date("*t")
		local currentday = time{year=d.year,month=d.month,day=d.day}
		local raidday = time{year=string.sub(index,1,4),month=string.sub(index,5,6),day=string.sub(index,7,8)}
		if currentday - raidday <= 1209600 then
			newtable[index] = value
		end
	end
	DEDKPRaids[DERR_REALM][DERR_GUILD] = newtable

	newtable = {}
	for index, value in pairs(DEDKPLoot[DERR_REALM][DERR_GUILD]) do
		local d = date("*t")
		local currentday = time{year=d.year,month=d.month,day=d.day}
		local raidday = time{year=string.sub(index,1,4),month=string.sub(index,5,6),day=string.sub(index,7,8)}
		if currentday - raidday <= 1209600 then
			newtable[index] = value
		end
	end
	DEDKPLoot[DERR_REALM][DERR_GUILD] = newtable

end
