local AceGUI = LibStub("AceGUI-3.0")

function DEDKP_VersionWindow_Show()
	DERR.VersionWindow = AceGUI:Create("Frame")
	DERR.VersionWindow:SetTitle("DERR Versions")
	DERR.VersionWindow:SetLayout("Flow")
	DERR.VersionWindow:SetWidth(280)
	DERR.VersionWindow:SetHeight(450)
	DERR.VersionWindow:EnableResize(false)
	DERR.VersionWindow:SetCallback("OnClose", DEDKP_VersionWindow_OnClose)

	--Version Scroll
	DERR.VersionWindow.VersionContainer = AceGUI:Create("InlineGroup")
	DERR.VersionWindow.VersionContainer:SetLayout("Fill")
	DERR.VersionWindow.VersionContainer:SetWidth(270)
	DERR.VersionWindow.VersionContainer:SetHeight(385)
	DERR.VersionWindow.VersionContainer:SetTitle("Version: "..DERR_VERSION)
	DERR.VersionWindow:AddChild(DERR.VersionWindow.VersionContainer)

	DERR.VersionWindow.VersionScroll = AceGUI:Create("ScrollFrame")
	DERR.VersionWindow.VersionScroll:SetLayout("Flow")
	DERR.VersionWindow.VersionContainer:AddChild(DERR.VersionWindow.VersionScroll)

	DEDKP_VersionWindow_LoadVersions()

	DraconisErus_SetWindowPosition("VersionWindow", DERR.VersionWindow)

end

function DEDKP_VersionWindow_LoadVersions()
	DEDKP_VersionWindow_SortVersions()
	DERR.VersionWindow.VersionScroll:ReleaseChildren()
	for _, user in pairs(DERR_USERS) do
		DEDKP_VersionWindow_AddVersionEntry(user.player,user.version, user.timestamp)
	end
end

function DEDKP_VersionWindow_AddVersionEntry(player, version, timestamp)
	local g = AceGUI:Create("SimpleGroup")
	g:SetLayout("Flow")

	local class = DraconisErus_Guild_GetClass(player)

	local il = AceGUI:Create("InteractiveLabel")
	il:SetText(player)
	il:SetHighlight("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	il:SetWidth(95)
	il.player = player
	il:SetColor(dedkp_class_info[class].r,dedkp_class_info[class].g,dedkp_class_info[class].b)
	g:AddChild(il)


	local l = AceGUI:Create("Label")
	l:SetText(version)
	l:SetWidth(95)
	if timestamp < DERR_VERSION_STAMP then
		l:SetColor(1,0,0)
	elseif timestamp == DERR_VERSION_STAMP then
		l:SetColor(1,1,1)
	else
		l:SetColor(0,1,0)
	end
	l:SetJustifyH("RIGHT")
	g:AddChild(l)

	DERR.VersionWindow.VersionScroll:AddChild(g)
end

function DEDKP_VersionWindow_OnClose(widget)
	if DERR.VersionWindow ~= nil then
		DraconisErus_SaveWindowPosition("VersionWindow", widget)
		widget:ReleaseChildren()
		widget:Hide()
		DERR.VersionWindow = nil
	end

end

function DEDKP_VersionWindow_RemoveVersion(player)
	if player ~= nil then
		for index, value in pairs(DERR_USERS) do
			if value.player == player then
				table.remove(DERR_USERS,index)
				break
			end
		end
	end
end

function DEDKP_VersionWindow_SortVersions()
	table.sort(DERR_USERS, function(a, b)
		if a.sort ~= b.sort then
			return a.sort > b.sort
		end
		return a.player < b.player
  	end)	
end

